#include "ReactorFortran.hh"
#include "ReactorEvent.hh"
#include "ReactorXC.hh"
#include <iostream.h>
#include <math.h>
#include <string.h>

int main(){
  //
  char* fileName0="th13.ntuple";
  char* ntName0="event data";
  int nevents = 10000;
  //
  // init random number seed
  //
  int luxury = 2;
  int seed = 8796896;
  int k1=0;
  int k2=0;
  rluxgo_(&luxury,&seed,&k1,&k2);

  int iostat;
  int ntId=1;
  int ntLun=99;
  int ntBuf=1024;
  //
  // reformat character strings to pass to fortran
  //
  char fileName[16];
  strcpy(fileName,fileName0);
  for(int n=strlen(fileName);n<16;n++)fileName[n]=' ';
  char ntName[16];
  strcpy(ntName,ntName0);
  for(int n=strlen(ntName);n<16;n++)ntName[n]=' ';
  //
  // define ntuple tags here
  //
  int wordsize = 8;
  int ntVars = 10;
  float tuple[ntVars];
  char ntTags[ntVars*wordsize];
  strcpy(ntTags+0*wordsize,"wtc      ");
  strcpy(ntTags+1*wordsize,"wtf      ");
  strcpy(ntTags+2*wordsize,"enu      ");
  strcpy(ntTags+3*wordsize,"KEp      ");
  strcpy(ntTags+4*wordsize,"pcos     ");
  strcpy(ntTags+5*wordsize,"KEn      ");
  strcpy(ntTags+6*wordsize,"ncos     ");
  strcpy(ntTags+7*wordsize,"vr       ");
  strcpy(ntTags+8*wordsize,"vcos     ");
  strcpy(ntTags+9*wordsize,"vphi     ");
  //
  // set up paw ntuple
  //  
  hbook_init__(&iostat,&ntId,&ntLun,&ntBuf,
	     fileName,ntName,&ntVars,ntTags);
  //
  // event loop
  //
  for (int events = 0;events<nevents;events++){

    ReactorEvent Event;

    tuple[0] = Event.GetXCWeight();
    tuple[1] = Event.GetFluxWeight();
    tuple[2] = Event.GetEnu();
    tuple[3] = Event.GetPositronKE();
    tuple[4] = Event.GetCosThetaLab();
    tuple[5] = Event.GetNeutronKE();
    tuple[6] = Event.GetNeutronCosTheta();
    tuple[7] = Event.GetVertexR();
    tuple[8] = Event.GetVertexCosTheta();
    tuple[9] = Event.GetVertexPhi();

    hfn_(&ntId,tuple);
  }
  //
  // close up paw
  //
  hbook_end__();
}
